import javax.microedition.io.file.*;
import javax.microedition.io.*;
import java.io.*;
import java.util.*;
import javax.microedition.rms.*;
public class congthuc
{
    RecordStore rs;
    public double pc(double a, double b)
    {
        double c = a + b;
        return c;
    }
    public double pt(double a, double b)
    {
        double c = a - b;
        return c;
    }
    public double pn(double a, double b)
    {
        double c = a * b;
        return c;
    }
    public double pch(double a, double b)
    {
        double c = a / b;
        return c;
    }
    public double[] ptb2(double a, double b, double c)
    {
        double delta = (b * b) - (4 * a * c);
        double[] kq = new double[2];
        if (delta >= 0)
        {
            kq[0] = (-b + Math.sqrt(delta)) / (2 * a);
            kq[1] = (-b - Math.sqrt(delta)) / (2 * a);
        }
        else
        {
            kq[1] = 0.1107;
        }
        return kq;
    }
    public String parse(String in)
    {
        try
        {
            String thuc = in.substring(0, in.indexOf("."));
            String thapphan = in.substring(in.indexOf(".") + 1);
            int tu = Integer.parseInt(thuc + thapphan);
            int mau = 1;
            for (int j = 0; j < thapphan.length(); j++) mau = mau * 10;
            int uc = ucln(Math.abs(tu), Math.abs(mau));
            return String.valueOf(tu / uc) + " / " + String.valueOf(mau / uc);
        }
        catch(Exception e)
        {
            return in;
        }
    }
    public int ucln(int a, int b)
    {
        int c;
        while (b > 0)
        {
            c = a % b;
            a = b;
            b = c;
        }
        return a;
    }


    //FileConnection
    public String luubonho(String link, String data)
    {
        try
        {
            FileConnection fc = (FileConnection) Connector.open(link);
            if (fc.exists())
            {
                return "tontai";
            }
            else
            {
                fc.create();
                OutputStream os = fc.openOutputStream();
                byte[] by = data.getBytes();
                os.write(by, 0, by.length);
                os.close();
                fc.close();
                return "ok";
            }
        }
        catch(Exception e)
        {
            return "loi";
        }
    }
    public String docbonho(String link)
    {
        try
        {
            FileConnection fc = (FileConnection) Connector.open(link);
            InputStream is = fc.openInputStream();
            StringBuffer sb = new StringBuffer();
            int i;
            while ((i = is.read()) != -1) sb.append((char) i);
            is.close();
            fc.close();
            return sb.toString();
        }
        catch(Exception e)
        {
            return "loi";
        }
    }



    //rms
    public String luurms(String data)
    {
        try
        {
            rs = RecordStore.openRecordStore("code_by_systemerror", true);
            byte[] by = data.getBytes();
            rs.addRecord(by, 0, by.length);
            return "ok";
        }
        catch(Exception e)
        {
            return "loi";
        }
    }
    public String docrms()
    {
        try
        {
            rs = RecordStore.openRecordStore("code_by_systemerror", true);
            byte[] recData = new byte[5];
            for (int i = 1; i <= rs.getNumRecords(); i++)
            {
                if (rs.getRecordSize(i) > recData.length)
                {
                    recData = new byte[rs.getRecordSize(i)];
                }
                int len = rs.getRecord(i, recData, 0);
                return new String(recData, 0, len) + "\n";
            }
            return null;
        }
        catch(Exception e)
        {
            return "loi";
        }
    }
    public String xoarms()
    {
        try
        {
            RecordStore.deleteRecordStore("code_by_systemerror");
            return "ok";
        }
        catch(Exception e)
        {
            return "loi";
        }
    }


    public String chuyen(Vector v)
    {
        StringBuffer sb = new StringBuffer();
        Enumeration e = v.elements();
        while (e.hasMoreElements())
        {
            sb.append(e.nextElement().toString());
        }
        return sb.toString();
    }
}

/*
    public Alert tontai()
    {
        Alert al = new Alert("thông báo", "file này đã tồn tại!", null, AlertType.WARNING);
        return al;
    }
*/